(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('grapesjs')) :
    typeof define === 'function' && define.amd ? define(['exports', 'react', 'grapesjs'], factory) :
    (global = global || self, factory(global.GrapesjsReact = {}, global.React, global.GrapesJS));
}(this, (function (exports, React, GrapesJS) { 'use strict';

    React = React && React.hasOwnProperty('default') ? React['default'] : React;
    GrapesJS = GrapesJS && GrapesJS.hasOwnProperty('default') ? GrapesJS['default'] : GrapesJS;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function GrapesjsReact(props) {
      var id = props.id,
          onInit = props.onInit,
          onDestroy = props.onDestroy,
          children = props.children,
          options = __rest(props, ["id", "onInit", "onDestroy", "children"]);

      var _a = React.useState(),
          editor = _a[0],
          setEditor = _a[1];

      React.useEffect(function () {
        var selector = "#" + id;

        if (!editor) {
          var editor_1 = GrapesJS.init(__assign({
            container: selector,
            fromElement: !!children
          }, options));
          setEditor(editor_1);

          if (typeof onInit === 'function') {
            onInit(editor_1);
          }
        }
      }, [children, editor, id, onInit, options]);
      React.useEffect(function () {
        return function cleanup() {
          if (editor) {
            if (typeof onDestroy === 'function') {
              onDestroy();
            }

            var index = GrapesJS.editors.findIndex(function (e) {
              return e.Config.container === editor.Config.container;
            });

            if (typeof index === 'number' && index >= 0) {
              GrapesJS.editors.splice(index, 1);
            }

            editor.destroy();
          }
        };
      }, [editor, onDestroy]);
      return React.createElement("div", {
        id: id
      }, children);
    }

    exports.GrapesjsReact = GrapesjsReact;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
